Difference between revisions of "Chroot"

From Alpine Linux
Jump to: navigation, search
(Some cleanup)
(Expansion and more cleanup)
Line 57: Line 57:
 
For more info, see:
 
For more info, see:
  
* http://en.wikibooks.org/wiki/Grsecurity
+
<ul type="circle">
* http://www.gentoo.org/proj/en/hardened/grsecurity.xml
+
<li>http://en.wikibooks.org/wiki/Grsecurity
 +
<li>http://www.gentoo.org/proj/en/hardened/grsecurity.xml
 +
</ul>
  
 
</ul>
 
</ul>
Line 68: Line 70:
 
{{Cat|/root/start-chroot|<nowiki>
 
{{Cat|/root/start-chroot|<nowiki>
 
#!/bin/sh -e
 
#!/bin/sh -e
 +
 
user=`whoami`
 
user=`whoami`
if [ "$user" != "root" ]; then
+
if [ root != "$user" ]; then
 
   echo "This script needs root access" >&2
 
   echo "This script needs root access" >&2
 
   exit 1
 
   exit 1
 
fi
 
fi
if ! [ -d "$1" ]; then
+
 
   echo "Usage: $0 <chroot directory>" >&2
+
if ! [ -d "$1" ] || [ x-h = x"$1"] || [x--help = x"$1"]; then
 +
   echo "Usage: ${0##*/} <chroot_directory>" >&2
 
   exit 1
 
   exit 1
 
fi
 
fi
 +
 
if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_chmod` ]; then
 
if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_chmod` ]; then
 
   echo "Warning: can't suid/sgid inside chroot" >&2
 
   echo "Warning: can't suid/sgid inside chroot" >&2
fi
 
if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_chroot` ]; then
 
  echo "Warning: can't chroot inside chroot" >&2
 
 
fi
 
fi
 
if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_mknod` ]; then
 
if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_mknod` ]; then
Line 89: Line 91:
 
   echo "Warning: can't mount inside chroot" >&2
 
   echo "Warning: can't mount inside chroot" >&2
 
fi
 
fi
 +
if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_chroot` ]; then
 +
  echo "Warning: can't chroot inside chroot" >&2
 +
fi
 +
 
cd "$1"
 
cd "$1"
 
shift
 
shift
cp -L /etc/resolv.conf ./etc/ || true
+
mkdir -p ./etc ./proc ./sys ./dev ./run ./tmp ./boot   # ./dev/pts ./dev/shm
mount -t proc proc ./proc
 
mount -t sysfs sys ./sys
 
mount -o bind /dev ./dev
 
# next line is said to be important for pacman's signature check
 
mount -o bind /dev/pts ./dev/pts
 
case $1 in
 
   -l) shift;;
 
  -l*) one=${1#-l}; shift; set -- -$one "$@";;
 
esac
 
chroot . /bin/sh -l "$@"
 
umount ./dev/pts
 
umount ./dev ./sys ./proc
 
</nowiki>}}
 
  
Copy that script to some location on your system, such as {{Path|/root/start-chroot}}, run <code>chmod +x</code> on it, and then invoke it as: {{Cmd|/root/start-chroot $CHROOT}}, where <code>$CHROOT</code> evaluates to the path you want to chroot into (for example, {{Path|/mnt}}).
+
cp -iL /etc/resolv.conf ./etc/ || true                            # if ^C, will cancel script
  
'''Comment on Environment variables, extra arguments to start-chroot.'''
+
mount --bind /dev ./dev
 +
mount -t devpts devpts ./dev/pts -o mode=0620,gid=5,nosuid,noexec  # important for pacman's signature check
 +
# mount -t tmpfs shm ./dev/shm -o mode=1777,nosuid,nodev  ## FIXME
  
It is certainly possible to perform a chroot by hand, without using this script. For some purposes, you can get away with a simpler procedure than the script follows. But it's hard to catalogue in advance when taking shortcuts will get you in trouble, so it's best to just get in the habit of using this script (or doing the same things it does). As you read around in various wikis (perhaps including this one), you will encounter a variety of instructions for how to chroot by hand. These instructions often differ in small details from each other and are usually not as thorough as the above script.
+
mount -t sysfs sys ./sys
  
 +
mount -t proc proc ./proc
  
 +
# mount -t tmpfs run ./run -o nosuid,nodev,mode=0755      ## FIXME
 +
# mount -t tmpfs tmp ./tmp -o mode=1777,strictatime,nodev,nosuid  ## FIXME
  
<!--
 
  
Performing the chroot
+
case $1 in
---------------------
+
  -l) shift;;
 +
  -l*) one=${1#-l}; shift; set -- -"$one" "$@";;
 +
esac
 +
chroot . /bin/sh -l "$@"
  
    cd /
+
# perhaps: source /etc/profile && export PS1="(chroot) $PS1"
    mount -t ext3 /dev/sda1 /mnt
 
    mount -t proc proc /mnt/proc
 
    mount -t sysfs sys /mnt/sys
 
    mount -o bind /dev /mnt/dev
 
  
If your `/boot` directory is on a different partition from your `/`, and you want to manipulate files on it (e.g., if you'll be working with GRUB, performing a kernel upgrade, etc.), you'll also need to mount that partition. If it's at /dev/sda2 and its filetype is ext2, then do:
+
# umount --recursive .
 +
umount ./dev/pts
 +
umount ./dev ./sys ./proc
  
    mount -t ext2 /dev/sda2 /mnt/boot
+
</nowiki>}}
  
Similarly for any other parts of your filesystem (`/var`, `/usr`) that reside on separate partitions but which you need access to. Generally when you're chrooting to fix something you won't need access to /home, so you don't need to bother with it.
 
  
(It's also possible to mount filesystems after you've chrooted, but it's smarter to do so beforehand. The reason is that when you do it after, the outside/kernel environment won't know about the mounted filesystems, so if you forget to umount them before exiting the chroot, the system won't know to umount them when it shuts down, either. This could damage those filesystems.)
+
Copy that script to some location on your system, such as {{Path|/root/start-chroot}}, run <code>chmod +x</code> on it, and then invoke it as:
 +
{{Cmd|/root/start-chroot $CHROOT}}
  
If you've setup your network and want to use it in the chrooted system, copy over `/etc/resolv.conf` so that you'll be able to resolve domain names:
+
TODO: Comment on Environment variables, extra arguments to start-chroot.
  
    cp -L /etc/resolv.conf /mnt/etc/resolv.conf
+
It is certainly possible to perform a chroot by hand, without using this script. For some purposes, you can get away with a simpler procedure than the script follows. But it's hard to catalogue in advance when taking shortcuts will get you in trouble, so it's best to just get in the habit of using this script (or doing the same things it does). As you read around in various wikis (perhaps including this one), you will encounter a variety of instructions for how to chroot by hand. These instructions often differ in small details from each other and are usually not as thorough as the above script.
  
Now you're ready to move into the mounted filesystem:
 
  
    chroot /mnt /bin/bash
+
=== Troubleshooting ===
  
(If this returns an error `chroot: cannot run command '/bin/bash': Exec format error`, this usually indicates that you booted with one architecture (e.g. x86_32) and are trying to chroot into another (e.g. x86_64). The solution is to use a LiveCD which has the same architecture as the system you want to chroot into.)
+
If you see the error:
  
At this point, you're still running the kernel you booted with, but all paths `/path` will refer to what used to be `/mnt/path`.
+
* <code>chroot: cannot run command '/bin/sh': Exec format error</code>, it is likely that the architectures of the host environment and the chroot environment do not match. For example, you booted with a 32bit Live CD and are trying to chroot into an x86_64 system.
 +
* <code>chroot: '/bin/sh': Permission denied</code>, try remounting the system with exec permissions: <code>mount -o remount,exec $CHROOT</code>
  
If you'll be doing anything with GRUB, you'll need to be sure your `/etc/mtab` file is up-to-date:
 
  
    grep -v rootfs /proc/mounts > /etc/mtab
 
  
 +
== Inside the chroot ==
  
It might also be helpful at this point to do:
+
At this point, you're still running the kernel you booted with, but all paths `/path` will refer to what used to be `/mnt/path`.
 
 
    source /etc/profile
 
    export PS1="(chroot) $PS1"  # add a reminder to your prompt
 
 
 
-->
 
  
 +
If you have multiple terminals open on or connected to the running system, the chroot will only be effective in the terminal that you performed it in.
  
 
+
Now you can perform whatever troubleshooting (or do whatever development work) you need to do:
== Inside the chroot ==
 
 
 
Now that you're inside the chroot, you can perform whatever troubleshooting you need to do:
 
  
 
* resintall GRUB to your disk's MBR
 
* resintall GRUB to your disk's MBR
 +
* rebuild your initramdisk (or initramfs image TODO)
 +
* fix your /etc/fstab
 +
* perform a kernel upgrade (or downgrade)
 +
* (re)install other packages using your package manager
 
* reset a forgotten password
 
* reset a forgotten password
* perform a kernel upgrade (or downgrade)
 
* rebuild your initramdisk
 
* fix your /etc/fstab
 
* reinstall packages using your package manager
 
* whatever
 
 
If you have multiple terminals open on or connected to the running system, the chroot will only be effective in the terminal that you performed it in.
 
  
 +
or whatever.
  
== Cleaning up ==
+
If you'll be doing anything with GRUB, you should first make sure that sure your {{Path|/etc/mtab}} file is up-to-date:
 
+
{{Cmd|grep -v rootfs /proc/mounts > /etc/mtab}}
<!--
 
  
When you're finished, ensure that all running programs have stopped. Then exit the chroot:
 
  
    exit
 
  
Now unmount all the partitions you mounted:
+
=== Run graphical applications from the chroot ===
  
    umount /mnt/boot # if you mounted this or any other separate partitions
+
If you have an X server running on your outside/host system, you can start graphical applications from inside the chroot. To allow the chroot environment to connect to the X server, you have to do this in the host system (either before chrooting, or in a terminal other than the one you performed the chroot in):
    umount /mnt/{proc,sys,dev}
+
{{Cmd|xhost +local:}}
  
Finally attempt to unmount your hard drive:
+
Then, to direct applications from the chroot to the X server, set the <code>DISPLAY</code> environment variable inside the chroot to match its value in the host environment (for the user who owns the X server). So for example, inside the chroot you might say:
 +
{{Cmd|export DISPLAY{{=}}:0}}
  
    umount /mnt
 
  
If you get an error saying that /mnt (or any other partition) is busy, this can mean one of two things:
 
  
  - A program was left running inside of the chroot.
+
== Cleaning up ==
  
  - Or more frequently: a mount point still exists on this mount. For example, /mnt/usr is still mounted when trying to unmount /mnt.
+
When you're finished, ensure that all running programs have stopped. Then exit the chroot:
 +
{{Cmd|exit}}
  
In the latter case, simply unmount the offending mount point first. To get a reminder of all the current mount points, run `mount` with no parameters.
+
If you started the chroot using the {{Path|start-chroot}} script, it will take care of umounting {{Path|/dev}}, {{Path|/proc}}, {{Path|/sys}}, {{Path|/tmp}}, and so on. Else you should do this by hand. In any case, you should umount any partitions like {{Path|/boot}} that you mounted yourself, and then umount the system partition at <code>$CHROOT</code> if appropriate.
  
Finally:
+
If you get an error saying that <code>$CHROOT</code> (or any partition inside it) is busy, this can mean one of two things:
  
    reboot
+
* A program was left running inside of the chroot.
 +
* Or more frequently, a mountpoint still exists on this mount. For example, {{Path|$CHROOT/usr}} is still mounted when trying to umount {{Path|$CHROOT}}.
  
-->
+
In the latter case, simply unmount the offending mountpoint first. To get a reminder of all the current mountpoints, run <code>mount</code> with no parameters.

Revision as of 00:51, 21 January 2015

Underconstruction clock icon gray.svg
This material is work-in-progress ...

Do not follow instructions here until this notice is removed.
(Last edited by Dubiousjim on 21 Jan 2015.)

"Changing root" or "chrooting" is a method for zooming in on part of your filesystem, so that, for example, /path will refer to what was formerly accessible at /mnt/path. The "root" in the expression "chroot" refers to the root filesystem /, not to the root user. (Though typically you will need root user privileges in order to chroot.)

A common reason for chrooting is to perform maintenance on existing systems where booting and/or logging in no longer works. One has to boot the hardware somehow, such as with an Installation or Rescue CD or USB; then one mounts the broken system and chroots into it and performs the repairs. Common examples are:

  • reinstalling the bootloader
  • rebuilding the initramfs image
  • upgrading or downgrading packages
  • resetting a forgotten password

Chrooting can also be used to create and host a separate virtualized installation of a system. This can be useful for:

  • Testing and development, with software that's too risky to deploy on a production system.
  • Software can be developed, built and tested in a chroot populated only with its expected dependencies.
  • Can run legacy software or other software whose supporting libraries or data files can't be installed in the host system.
  • Open file descriptors (for files, pipelines and network connections) can be "carried into" the chroot by running programs, making it unnecessary for those programs' working files to be visible inside the chroot directory. This can help separate privileges or design sandboxes. Note that chroot is not a secure way to contain a hostile process with root privileges. See Wikipedia's discussion of some of chroot's limits.

Here are some other resources:

Preparation

  • All the steps in this guide will have to be performed as root user.
  • If you are using chroot to repair an existing Linux system, it will need to be mounted first. If you don't know the location and/or filetype of the disk(s) where it resides, read the output of fdisk -l or lsblk. We will suppose the broken system is at /dev/sdx1 and its filetype is ext3. Create a directory for mounting this disk, and mount it:

    mkdir -p $CHROOT
    mount -t ext3 /dev/sdx1 $CHROOT

    where $CHROOT evaluates to the path you want to chroot into (for example, /mnt).

    If the system directory is encrypted or in a LVM group or anything like that, we'll leave it to you to figure out what steps to take to prepare it and mount it.

  • If there are separate filesystems for other directories (such as /boot, /var, /usr, /home), mount them too:

    mount /dev/sdx2 $CHROOT/boot
    mount /dev/sdx3 $CHROOT/var
    mount /dev/sdx4 $CHROOT/usr

    For many repair tasks, you may not need to mount the broken system's /home directory.

    If you do have /boot on a separate partition, it's essential to have it mounted before working with GRUB, performing a kernel upgrade, or anything of that sort. It's also possible to mount some of these filesystems after you've chrooted, and in some cases mounting /boot in particular after chrooting has worked better with GRUB. If you can, though, it's smarter to mount these beforehand. The reason is that if you do it from inside the chroot, the outside/host environment won't know about the mounted filesystems, so if you forget to umount them before exiting the chroot, the system won't know to umount them when it shuts down, either. That could damage those filesystems.

  • The script presented below will take care of generating or remounting other system directories like /dev, /proc, /sys, /tmp and so on.
  • The architecture of the host system you're booted into (e.g., if it's a 32bit LiveCD, that's x86) and the system you want to chroot into must match. You can determine what architecture you're booted into using uname -m.
  • Before chrooting, be sure any kernel modules you'll need when working inside the chroot have been loaded. For example:

    modprobe dm-mod
    modprobe dm-crypt

  • Set up your network if you'll need it inside the chroot, e.g., to install updated packages. The script presented below will copy the /etc/resolv.conf from the host system, but will prompt before overwriting an existing etc/resolv.conf inside the chroot. If you like, you can generate one from scratch by doing:

    echo 'nameserver 8.8.8.8' > $CHROOT/etc/resolv.conf

  • If your host system is Alpine or another distribution (like Hardened Gentoo) that uses the grsecurity kernel patches, for some maintenance tasks you'll want to make sure some of the grescurity prohibitions are disabled. For example:

    sysctl -w kernel.grsecurity.chroot_deny_chmod=0 # enable suid/sgid
    sysctl -w kernel.grsecurity.chroot_deny_mknod=0
    sysctl -w kernel.grsecurity.chroot_deny_mount=0
    sysctl -p

    For more info, see:

Performing the chroot

The most reliable way to chroot is to use the following script:

Contents of /root/start-chroot

#!/bin/sh -e user=`whoami` if [ root != "$user" ]; then echo "This script needs root access" >&2 exit 1 fi if ! [ -d "$1" ] || [ x-h = x"$1"] || [x--help = x"$1"]; then echo "Usage: ${0##*/} <chroot_directory>" >&2 exit 1 fi if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_chmod` ]; then echo "Warning: can't suid/sgid inside chroot" >&2 fi if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_mknod` ]; then echo "Warning: can't mknod inside chroot" >&2 fi if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_mount` ]; then echo "Warning: can't mount inside chroot" >&2 fi if [ x1 = x`sysctl -ne kernel.grsecurity.chroot_deny_chroot` ]; then echo "Warning: can't chroot inside chroot" >&2 fi cd "$1" shift mkdir -p ./etc ./proc ./sys ./dev ./run ./tmp ./boot # ./dev/pts ./dev/shm cp -iL /etc/resolv.conf ./etc/ || true # if ^C, will cancel script mount --bind /dev ./dev mount -t devpts devpts ./dev/pts -o mode=0620,gid=5,nosuid,noexec # important for pacman's signature check # mount -t tmpfs shm ./dev/shm -o mode=1777,nosuid,nodev ## FIXME mount -t sysfs sys ./sys mount -t proc proc ./proc # mount -t tmpfs run ./run -o nosuid,nodev,mode=0755 ## FIXME # mount -t tmpfs tmp ./tmp -o mode=1777,strictatime,nodev,nosuid ## FIXME case $1 in -l) shift;; -l*) one=${1#-l}; shift; set -- -"$one" "$@";; esac chroot . /bin/sh -l "$@" # perhaps: source /etc/profile && export PS1="(chroot) $PS1" # umount --recursive . umount ./dev/pts umount ./dev ./sys ./proc


Copy that script to some location on your system, such as /root/start-chroot, run chmod +x on it, and then invoke it as:

/root/start-chroot $CHROOT

TODO: Comment on Environment variables, extra arguments to start-chroot.

It is certainly possible to perform a chroot by hand, without using this script. For some purposes, you can get away with a simpler procedure than the script follows. But it's hard to catalogue in advance when taking shortcuts will get you in trouble, so it's best to just get in the habit of using this script (or doing the same things it does). As you read around in various wikis (perhaps including this one), you will encounter a variety of instructions for how to chroot by hand. These instructions often differ in small details from each other and are usually not as thorough as the above script.


Troubleshooting

If you see the error:

  • chroot: cannot run command '/bin/sh': Exec format error, it is likely that the architectures of the host environment and the chroot environment do not match. For example, you booted with a 32bit Live CD and are trying to chroot into an x86_64 system.
  • chroot: '/bin/sh': Permission denied, try remounting the system with exec permissions: mount -o remount,exec $CHROOT


Inside the chroot

At this point, you're still running the kernel you booted with, but all paths `/path` will refer to what used to be `/mnt/path`.

If you have multiple terminals open on or connected to the running system, the chroot will only be effective in the terminal that you performed it in.

Now you can perform whatever troubleshooting (or do whatever development work) you need to do:

  • resintall GRUB to your disk's MBR
  • rebuild your initramdisk (or initramfs image TODO)
  • fix your /etc/fstab
  • perform a kernel upgrade (or downgrade)
  • (re)install other packages using your package manager
  • reset a forgotten password

or whatever.

If you'll be doing anything with GRUB, you should first make sure that sure your /etc/mtab file is up-to-date:

grep -v rootfs /proc/mounts > /etc/mtab


Run graphical applications from the chroot

If you have an X server running on your outside/host system, you can start graphical applications from inside the chroot. To allow the chroot environment to connect to the X server, you have to do this in the host system (either before chrooting, or in a terminal other than the one you performed the chroot in):

xhost +local:

Then, to direct applications from the chroot to the X server, set the DISPLAY environment variable inside the chroot to match its value in the host environment (for the user who owns the X server). So for example, inside the chroot you might say:

export DISPLAY=:0


Cleaning up

When you're finished, ensure that all running programs have stopped. Then exit the chroot:

exit

If you started the chroot using the start-chroot script, it will take care of umounting /dev, /proc, /sys, /tmp, and so on. Else you should do this by hand. In any case, you should umount any partitions like /boot that you mounted yourself, and then umount the system partition at $CHROOT if appropriate.

If you get an error saying that $CHROOT (or any partition inside it) is busy, this can mean one of two things:

  • A program was left running inside of the chroot.
  • Or more frequently, a mountpoint still exists on this mount. For example, $CHROOT/usr is still mounted when trying to umount $CHROOT.

In the latter case, simply unmount the offending mountpoint first. To get a reminder of all the current mountpoints, run mount with no parameters.